%% Espectrograma de canto de ballenas
%% Caso 1: Comparacion de resultados sin y con arreglos graficos
    %Cargar datos y calculo de espectrograma
    clear; clc; close all;
    [Registro,Fs] = audioread('Humpback_whale_song_2_64kb.mp3');
    Registro=detrend(Registro);
    spect(Registro,Fs,0.3,0.1);
    %Escuchar el registro
    %sound(Registro,Fs);
%% Cambiando los limites de estudio
    ylim([0 2000]); 
%% Saturando para grandes amplitudes
    c=colorbar('southoutside'); limite=30;    
    set(c, 'ylim', [0 limite]); caxis([0 limite]);
    
%% Caso 2: Comparacion para diferentes anchos de ventana
    figure();
    Largo_Ventana = [0.2 1 5 10]; %Ventana=round(Ventana*Fs); 
    for i=1:4
        subplot(2,2,i); 
        spect_solo(Registro,Fs,Largo_Ventana(i),0.1); ylim([0 2000]); 
        limite=30; caxis([0 limite]);
        titulo = strcat('Largo de ventana = ', num2str(Largo_Ventana(i)), '[s]');
        title(titulo);
    end
    
%% Caso 3: Comparacion para diferentes porcentajes de traslape
    figure();
    Traslape = [0 0.2 0.5 0.9]; %Traslape=round(Traslape*Ventana);
    for i=1:4
        subplot(2,2,i); 
        spect_solo(Registro,Fs,3,Traslape(i)); ylim([0 2000]); 
        limite=30; caxis([0 limite]);
        titulo = strcat('Traslape = ', num2str(Traslape(i)*100), '%');
        title(titulo);
    end
%% Caso 4: Utilidad del espectrograma
    clear;
    % Registro sintetico
    figure();
    t = 0:0.1:100; Registro = zeros(length(t),1)';
    Arreglo = {1:length(t) 300:600 100:800 1:500 400:900};
    Arreglo2 = [1 3 0.1 0.4 5];
    for i=1:length(Arreglo)
        aux = zeros(length(t),1)'; Indices = Arreglo {i};
        aux(Indices) = sin(t(Indices)*Arreglo2(i)*pi);
        subplot(length(Arreglo)+1,1,i); plot(aux); axis tight;
        Registro = Registro + aux;
    end
    subplot(length(Arreglo)+1,1,length(Arreglo)+1);plot(Registro); axis tight
    aux = sin(t*pi);
    subplot(5,1,1); plot(aux); axis tight;
    %% Espectrograma
    spect(Registro,10,15,0.9);
    


